pico-8 cartridge // http://www.pico-8.com
version 8
__lua__
--red planet iv
--v47

cartdata"rpiv"

states = {}
git,git_count = "a827e63","47"
states.cutscene = {}

function states.cutscene.load(self)
self.c = {
{
{place='level1'},
{placetext='earth is all but lost!'},
{place='level2'},
{placetext='level 2'},
{place='level3'},
{placetext='level 3'},
{person0='alitahugo',},
{persontext='i will save it!'},
{person1='alitahugo'},
{persontext='no, i will save it!'},
{person1='mssinfested'},
{persontext='i will destroy it!'},
},
}
self.c = story
end

function states.cutscene.enter(self)
self.frame = 0
self:nextframe()
music(musicdata.cutscene[self.current])
menuitem(1,"skip cutscene",function()
self.frame = #self.c[self.current]
self.fadein = 100
end)
unlocked[self.current] = true
end

function states.cutscene.draw(self)
cls()
pallight(self.fadein or 100)
spr(0,0,0,16,16)
pal()
local frame = self.c[self.current][self.frame]
if frame.placetext or frame.persontext then
local text = sub(frame.placetext or frame.persontext,1,self.textlen)
local xoffset = (128 - #text*4)/2
local yoffset = 128-8-4
if frame.placetext then
yoffset = 96-4
end
printb(text,xoffset,yoffset)
end
end

function states.cutscene.update(self)
self.textlen += 1
if self.fadein then
self.fadein = min(100,self.fadein + 4)
if self.fadein >= 100 then
self.fadein = nil
self:nextframe()
end
end
if btnp(4) or btnp(5) then
if self.textlen <= 32 then
self.textlen = 32
else
self:nextframe()
end
end
end

function states.cutscene.nextframe(self)
self.textlen = 0
self.frame += 1
local frame = self.c[self.current][self.frame]
if not frame then
if nextState and nextState ~= states.cutscene then
changeState(nextState)
elseif self.current == 4 then
changeState(states.menu)
else
changeState(states.game)
end
menuitem(1)
else
if frame.place or frame.person0 or frame.person1 then
self.fadein = 0
self.place = frame.place or false
load_ss(
frame.place or frame.person0 or frame.person1,
frame.person0 and 0 or (frame.person1 and 1 or nil))
end
end
end
states.game = {}
function states.game.init(self)
self.firing_pattern = {
[0] = {0},
[1] = {-1,1},
[2] = {-1,1},
[3] = {-2,0,2},
}
self.player = {
score = 0,
x = 64,
y = 96,
bullets = {},
bullets_reload = 0,
cloak = 0,
cloak_reload = 0,
shield = 3,
upgrades = {
fire = 0,
speed = 0,
shield = 0,
cloak = 0,
},
}
self.level = 1
self.level_bg = {
function(sx,sy)
for i = 0,1 do
spr(128,i*64+sx,-64+self.bgoffset+sy,8,8)
spr(128,i*64+sx,0+self.bgoffset+sy,8,8)
spr(128,i*64+sx,64+self.bgoffset+sy,8,8)
end
end,
function(sx,sy)
for i = 0,1 do
spr(136,i*64+sx,-64+self.bgoffset+sy,8,4)
spr(136,i*64+sx,-32+self.bgoffset+sy,8,4)
spr(136,i*64+sx,0+self.bgoffset+sy,8,4)
spr(136,i*64+sx,32+self.bgoffset+sy,8,4)
spr(136,i*64+sx,64+self.bgoffset+sy,8,4)
spr(136,i*64+sx,96+self.bgoffset+sy,8,4)
end
end,
function(sx,sy)
for i = 0,1 do
spr(200,i*64+sx,-64+self.bgoffset+sy,8,4,i==1)
spr(200,i*64+sx,-32+self.bgoffset+sy,8,4,i==1)
spr(200,i*64+sx,0+self.bgoffset+sy,8,4,i==1)
spr(200,i*64+sx,32+self.bgoffset+sy,8,4,i==1)
spr(200,i*64+sx,64+self.bgoffset+sy,8,4,i==1)
spr(200,i*64+sx,96+self.bgoffset+sy,8,4,i==1)
end
end
}
end
function states.game.enter(self)
music(musicdata.level[self.level])
self.player.x = 64
self.player.y = 96
self.player.shield = self.player.upgrades.shield
self.player.cloak = 0
self.player.cloak_reload = 0
self.player.bullets = {}
for x = 0,127 do
for y = 0,127 do
sset(x,y,spr_orig[x][y])
end
end
self.enemies = {}
self.enemies_stack = {}
if self.level == 1 then
add(self.enemies_stack,enemy_boss(1))
for i = 1,10 do
add(self.enemies_stack,enemy_large())
add(self.enemies_stack,enemy_small())
add(self.enemies_stack,enemy_small())
add(self.enemies_stack,enemy_small())
add(self.enemies_stack,enemy_small())
end
elseif self.level == 2 then
add(self.enemies_stack,enemy_boss(2))
for i = 1,15 do
add(self.enemies_stack,enemy_large())
add(self.enemies_stack,enemy_small())
add(self.enemies_stack,enemy_large())
add(self.enemies_stack,enemy_small())
end
else
add(self.enemies_stack,enemy_boss(3))
for i = 1,20 do
add(self.enemies_stack,enemy_large())
add(self.enemies_stack,enemy_small())
add(self.enemies_stack,enemy_large())
add(self.enemies_stack,enemy_small())
add(self.enemies_stack,enemy_large())
add(self.enemies_stack,enemy_small())
end
end
self.enemy_spawn = 120
self.explosions = {}
self.bullets = {}
self.bgoffset = 0
self.shakeinten = 0
self.gameover = nil
self.nextlevel = nil
self.fadein = 0
pallight(self.fadein)
end
function clamp(i,mini,maxi)
return max(mini,min(maxi,i))
end
function intersect(a,b,range)
return abs(a.x - b.x) < range and abs(a.y - b.y) < range
end
function states.game.damage(self)
if self.player.cloak > 0 then
return
elseif self.player.shield == 0 then
if not self.gameover then
sfx(sfxdata.playerdeath)
self.gameover = 100
end
else
self.player.shield -= 1
end
self.shakeinten = 30
self.player.cloak = 60
end
function enemy_small()
return {
hp = 2,
x = flr(rnd(120))+4,
y = -8,
reload = 0,
direction = flr(rnd(2))*2-1,
type = {
sprite = ss.enemy.small[flr(rnd(#ss.enemy.small))+1],
offset = 4,
size = 1,
death = function(self)
states.game.player.score += 5
sfx(sfxdata.explosion)
local explosion = {
x = self.x,
y = self.y,
time = 30,
}
add(states.game.explosions,explosion)
end,
update = function(self)
self.y += 2
self.reload = max(0,self.reload-1)
self.direction = self.x < 4 and 1 or (self.x > 124 and -1 or self.direction)
self.x += self.direction
if self.reload <= 0 then
self.reload = 30
local bullet = {
x = self.x,
y = self.y,
}
add(states.game.bullets,bullet)
end
end,
}
}
end
function enemy_large()
return {
hp = 8,
x = flr(rnd(120))+4,
y = -16,
reload = 0,
direction = flr(rnd(2))*2-1,
type = {
sprite = ss.enemy.large[flr(rnd(#ss.enemy.large))+1],
offset = 8,
size = 2,
death = function(self)
states.game.player.score += 20
sfx(sfxdata.explosion)
for _,v in pairs({{-1,-1},{-1,1},{1,-1},{1,1},{0,0}}) do
local explosion = {
x = self.x+v[1]*8,
y = self.y+v[2]*8,
time = 30,
}
add(states.game.explosions,explosion)
end
end,
update = function(self)
self.y += 1
self.reload = max(0,self.reload-1)
self.direction = self.x < 4 and 1 or (self.x > 124 and -1 or self.direction)
self.x += self.direction
if self.reload <= 0 then
self.reload = 30
for i = -1,1 do
local bullet = {
x = self.x+i*8,
y = self.y,
}
add(states.game.bullets,bullet)
end
end
end,
}
}
end
function enemy_boss(n)
local offset = {12,16,24}
local size = {3,4,6}
return {
hp = offset[n]*20,
x = 63,
y = -128,
reload = 0,
direction = flr(rnd(2))*2-1,
type = {
sprite = ss.enemy.boss[n],
offset = offset[n],
size = size[n],
spawn = function(self)
music(musicdata.boss[n])
end,
death = function(self)
states.game.player.score += 50*offset[n]
sfx(sfxdata.bigexplosion)
for _,v in pairs({{-1,-1},{-1,1},{1,-1},{1,1},{0,0}}) do
local explosion = {
x = self.x+v[1]*12,
y = self.y+v[2]*12,
time = 30,
}
add(states.game.explosions,explosion)
end
end,
update = function(self)
self.y = min(self.y + 1,32)
self.direction = self.x < 16 and 1 or (self.x > 96 and -1 or self.direction)
if self.y == 32 then
self.x += self.direction*n
end
self.reload = max(0,self.reload-1)
if self.reload <= 0 then
self.reload = 85 - n*15
for i = -n,n do
local bullet = {
x = self.x+i*8,
y = self.y,
}
add(states.game.bullets,bullet)
end
end
end,
}
}
end
function states.game.update(self)
self.shakeinten = max(0,self.shakeinten-1)
if self.fadein then
self.fadein = min(100,self.fadein + 4)
pallight(self.fadein)
if self.fadein >= 100 then
self.fadein = nil
end
end
if not self.nextlevel and #self.enemies == 0 and #self.enemies_stack == 0 then
self.nextlevel = 100
end
self.bgoffset = (self.bgoffset + 1)%64
self.enemy_spawn = max(0,self.enemy_spawn-1)
if self.enemy_spawn == 0 then
self.enemy_spawn = hard and 10-self.level*3 or 60-self.level*15
local enemy = self.enemies_stack[#self.enemies_stack]
if enemy then
del(self.enemies_stack,enemy)
add(self.enemies,enemy)
if enemy.type.spawn then
enemy.type.spawn(enemy)
end
end
end
for _,enemy in pairs(self.enemies) do
enemy.type.update(enemy)
if enemy.y > 128 then
del(self.enemies,enemy)
end
if intersect(enemy,self.player,8) then
self:damage()
end
end
for _,bullet in pairs(self.bullets) do
bullet.y += 2
if bullet.y > 128 then
del(self.bullets,bullet)
elseif intersect(bullet,self.player,8) then
self:damage()
del(self.bullets,bullet)
end
end
for _,bullet in pairs(self.player.bullets) do
bullet.y -= 4
if bullet.y < 0 then
del(self.player.bullets,bullet)
end
for _,enemy in pairs(self.enemies) do
if intersect(enemy,bullet,enemy.type.size*4) then
if enemy.hp > 1 then
enemy.hp -= 1
local explosion = {
x = bullet.x,
y = bullet.y,
time = 30,
}
add(self.explosions,explosion)
else
del(self.enemies,enemy)
enemy.type.death(enemy)
end
del(self.bullets,bullet)
end
end
end
for _,explosion in pairs(self.explosions) do
explosion.time = max(0,explosion.time-1)
if explosion.time == 0 then
del(self.explosions,explosion)
end
end
if btn(0) then
self.player.x -= (self.player.upgrades.speed/2+1.5)
end
if btn(1) then
self.player.x += (self.player.upgrades.speed/2+1.5)
end
if btn(2) then
self.player.y -= (self.player.upgrades.speed/2+1.5)
end
if btn(3) then
self.player.y += (self.player.upgrades.speed/2+1.5)
end
if self.gameover then
self.player.y += 4
self.player.y += 4
else
self.player.x = clamp(self.player.x,4,124)
self.player.y = clamp(self.player.y,4+32,124)
end
self.player.bullets_reload = max(0,self.player.bullets_reload-1)
if self.player.bullets_reload == 0 and btn(4) then
sfx(sfxdata.weapon)
self.player.bullets_reload = 8-self.player.upgrades.fire
for _,v in pairs(self.firing_pattern[self.player.upgrades.fire]) do
local bullet = {
x = self.player.x+v*4,
y = self.player.y,
}
add(self.player.bullets,bullet)
end
end
self.player.cloak_reload = max(0,self.player.cloak_reload-1)
self.player.cloak = max(0,self.player.cloak-1)
if self.player.cloak_reload == 0 and btn(5) then
sfx(sfxdata.cloaking)
self.player.cloak_reload = 60*5-self.player.upgrades.cloak*60
self.player.cloak = 60
end
if self.gameover then
self.gameover = max(0,self.gameover - 4)
pallight(self.gameover)
if self.gameover == 0 then
self.gameover = nil
nextState = states.cutscene
changeState(states.resist)
end
end
if self.nextlevel then
self.nextlevel = max(0,self.nextlevel - 4)
pallight(self.nextlevel)
if self.nextlevel == 0 then
self.level += 1
states.cutscene.current += 1
changeState(states.cutscene)
end
end
end
function states.game.s(self)
return (flr(rnd(5))-2)*(self.shakeinten/10)
end
function states.game.draw(self)
cls()
self.level_bg[self.level](self:s(),self:s())
palt(7,true)
palt(0,false)
for _,bullet in pairs(self.bullets) do
spr(ss.enemy_bullet,bullet.x-4+self:s(),bullet.y-4+self:s())
end
for _,bullet in pairs(self.player.bullets) do
spr(ss.player_bullet,bullet.x-4+self:s(),bullet.y-4+self:s())
end
for _,enemy in pairs(self.enemies) do
spr(enemy.type.sprite,
enemy.x-enemy.type.offset+self:s(),
enemy.y-enemy.type.offset+self:s(),
enemy.type.size,
enemy.type.size)
end
for _,explosion in pairs(self.explosions) do
local sprite = ss.explosion[3]
if explosion.time > 20 then
sprite = ss.explosion[2]
elseif explosion.time > 10 then
sprite = ss.explosion[1]
end
spr(sprite,explosion.x-4+self:s(),explosion.y-4+self:s())
end
if self.player.cloak > 0 then
spr(ss.player[2],self.player.x-8+self:s(),self.player.y-8+self:s(),2,2)
else
spr(ss.player[1],self.player.x-8+self:s(),self.player.y-8+self:s(),2,2)
end
if self.player.cloak_reload == 0 then
spr(ss.ui.cloak[2],4+self:s(),116+self:s())
else
spr(ss.ui.cloak[1],4+self:s(),116+self:s())
end
for i = 1,self.player.upgrades.shield do
if self.player.shield < i then
spr(ss.ui.shield[1],i*8+8+self:s(),116+self:s())
else
spr(ss.ui.shield[2],i*8+8+self:s(),116+self:s())
end
end
palt()
printc(self.player.score.."",2+self:s())
if hard then
printc("!easy mode!",28)
end
end
function load_ss(image,index)

local map = {
[0] = 0,
[1] = 3,
[2] = 7,
[3] = 11,
}

for x = 0,127 do
for y = 0,127 do
sset(x,y,flr(rnd(15)))
end
end

reload(0,0,0x2000,image..".p8")

if index then
for x = 0,127 do
for y = 0,127 do
local img_val = sget(x,y)
if index == 0 then
img_val = map[img_val%4]
elseif index == 1 then
img_val = map[flr(img_val/4)]
end 
sset(x,y,img_val)
end
end
end

return true 
end
function changeState(state)
_update = function() state:update() end
_draw = function() state:draw() end
if not state.__loaded then
state.__loaded = true
if state.load then
state:load()
end
end
if state.enter then
state:enter()
end
end
function _init()
spr_orig = {}
for x = 0,127 do
spr_orig[x] = {}
for y = 0,127 do
spr_orig[x][y] = sget(x,y)
end
end
changeState(states.splash)
end
function _validate_color(col)
assert(col == 0 or col == 3 or col == 7 or col == 11 or col == nil)
end
_color = color
function color(col)
_validate_color(col)
_color(col)
end
_pal = pal
function pal(c0,c1,p)
_validate_color(c0)
_validate_color(c1)
if c0 then
_pal(c0,c1,p)
else
_pal()
end
end
function printb(t,x,y,c)
color(3)
for _,v in pairs({{-1,0},{1,0},{0,-1},{0,1}}) do
print(t,x+v[1],y+v[2])
end
color(0)
for _,v in pairs({{-1,-1},{1,1},{1,-1},{-1,1}}) do
print(t,x+v[1],y+v[2])
end
color(c or 7)
print(t,x,y)
end

function printf(t,x,y,w,c)
printb(t,x+(w-#t*4)/2,y,c)
end

function printc(t,y,c)
printf(t,0,y,128,c)
end

function pallight(i)
i = i or 100
if i > 75 then
pal(0,0) pal(3,3) pal(11,11) pal(7,7)
elseif i > 50 then
pal(0,0) pal(3,0) pal(11,3) pal(7,11)
elseif i > 25 then
pal(0,0) pal(3,0) pal(11,0) pal(7,3)
else
pal(0,0) pal(3,0) pal(11,0) pal(7,0)
end
end

states.menu = {}

function states.menu.changeMenu(self,menu)
self.curm = self.m[menu]
end

function states.menu.load(self)
self.m = {}

self.m.main= {
{
text = function() return "new game" end,
exec = function()
states.game:init()
states.cutscene.current = 1
changeState(states.cutscene)
end,
},
{
text = function() return "story" end,
exec = function()
load_ss('alitahugo',1)
self:changeMenu("story")
end,
},
{
text = function() return "options" end,
exec = function()
load_ss('mssinfested',1)
self:changeMenu("options")
end,
},
{
text = function() return "music" end,
exec = function()
load_ss('alitahugo',1)
self:changeMenu("sound")
end,
},
{
text = function() return "credits" end,
exec = function()
load_ss('alitahugo',0)
self:changeMenu("credits")
end,
},
}

local return_to_menu = {
text = function() return "back" end,
exec = function()
load_ss('alitahugo',0)
self:changeMenu("main")
end,
}

local ls = " (locked)"

self.m.story = {
{
text = function()
return "level 1"..(unlocked[1] and "" or ls)
end,
exec = function()
if not unlocked[1] then return end
states.cutscene.current = 1
nextState = states.menu
changeState(states.cutscene)
end
},
{
text = function() return "level 2 (locked)" end,
text = function()
return "level 2"..(unlocked[2] and "" or ls)
end,
exec = function()
if not unlocked[2] then return end
states.cutscene.current = 2
nextState = states.menu
changeState(states.cutscene)
end
},
{
text = function()
return "level 3"..(unlocked[3] and "" or ls)
end,
exec = function()
if not unlocked[3] then return end
states.cutscene.current = 3
nextState = states.menu
changeState(states.cutscene)
end
},
{
text = function()
return "ending"..(unlocked[4] and "" or ls)
end,
exec = function()
if not unlocked[4] then return end
states.cutscene.current = 4
nextState = states.menu
changeState(states.cutscene)
end
},
return_to_menu,
}

self.diff = 1
self.diff_string = {
"difficulty: hard",
"difficulty: just as hard",
"difficulty: still hard",
"wait, is the game not hard?",
"i think it's hard...",
"i'm really good at shmups.",
"i got to level 2.",
"...",
"this isn't an easter egg...",
"baka sempai ... nyan ...",
"hold up.",
"are you saying that i'm bad?",
"how dare you insult me!",
"i just made this game...",
"but no, you had to press it.",
"and push my buttons.",
"fine.",
"have it your way.",
"your ass is grass.",
"difficulty: easy",
}

self.m.options = {
{
text = function() return self.diff_string[self.diff] end,
exec = function()
if self.diff == #self.diff_string-1 then
hard=true
self.subtitle = "video games are easy"
end
self.diff = self.diff_string[self.diff+1] and self.diff+1 or self.diff
end,
},
return_to_menu,
}

self.m.sound = {
{
text = function() return "level ["..self.music_level.."]" end,
qexec = function() self.music_level = self.music_level%4+1 end,
},
{
text = function() return "play cutscene "..self.music_level end,
qexec = function()
local pattern = musicdata.cutscene[self.music_level]
if pattern then 
music(pattern)
end
end,
},
{
text = function() return "play level "..self.music_level end,
qexec = function()
local pattern = musicdata.level[self.music_level]
if pattern then 
music(pattern)
end
end,
},
{
text = function() return "play boss "..self.music_level end,
qexec = function()
local pattern = musicdata.boss[self.music_level]
if pattern then 
music(pattern)
end
end,
},
return_to_menu,
}

self.m.credits = {
{text = function() return "#fc_jam + #awfuljams" end,},
{text = function() return "git:v"..git_count.."["..git.."]" end,},
{text = function() return "code: josefnpat" end,},
{text = function() return "art: bytedesigning" end,},
{text = function() return "music/sfx: johnplzplaybass" end,},
return_to_menu,
}

self.subtitles = {
"collector's edition box set",
"pre-order bonus dlc",
"early access prerelease alpha",
"not steam edition",
"game of the year edition",
"virtual reality release",
"internal preview copy",
"do not distribute",
"pirated version",
"insert subtitle here",
"send help",
"sleep is for the weak",
}
self.title = "r e d  p l a n e t  i v"
unlocked = {}
end

function states.menu.enter(self)
self.curm = self.m.main
self.cur = 1
self.fadeout = nil
self.fadein = 100
load_ss('alitahugo',0)
self.music_level = 1
music(musicdata.menu)
local subindex = flr(rnd(#self.subtitles)+1)
self.subtitle = self.subtitles[subindex]
end

function states.menu.draw(self)
cls()
pallight(74-(self.fadeout or self.fadein or 0))
spr(0,0,0,16,16)
pal()
color(0)
local offset = 128-8*(#self.curm+2)
for i,v in pairs(self.curm) do
local wrap = self.cur == i and "- " or ""
local textoffset = (self.fadeout or self.fadein or 0)*(self.cur == i and 1 or -1)
printb(wrap..v.text(),8+textoffset*2,8*(i-1)+offset)
end
color(0)
for x = -2,2,2 do
for y = -10,0 do
print(self.title,16+x,32+y)
end
end
printb(self.title,16,32)
printc(self.subtitle,40,3)
end

function states.menu.update(self)
if not self.fadeout then
if btnp(2) then
self.cur -= 1
sfx(sfxdata.menuscroll)
elseif btnp(3) then
self.cur += 1
sfx(sfxdata.menuscroll)
end
if self.cur == 0 then
self.cur = #self.curm
end
if self.cur > #self.curm then
self.cur = 1
end
end

if btnp(4) or btn(5) then
if self.curm[self.cur].exec and not self.fadeout and not self.fadein then
sfx(sfxdata.pushstart)
self.fadeout = 0
elseif self.curm[self.cur].qexec then
sfx(sfxdata.pushstart)
self.curm[self.cur].qexec()
end
end

if self.fadeout then
self.fadeout = self.fadeout + 4
if self.fadeout > 100 then
self.curm[self.cur].exec()
self.fadein = 100
self.cur = 1
self.fadeout = nil
end
end

if self.fadein then
self.fadein = self.fadein - 4
if self.fadein <= 0 then
self.fadein = nil
end
end
end
states.resist = {}

function states.resist.load(self)
self.deaths = 0
end

function states.resist.enter(self)
self.continue = true
self.fadein = 0
self.fadeout = nil
self.deaths += 1
load_ss('level1')
end

function states.resist.draw(self)
cls()
spr(0,0,0,16,16)
printc("you are shot down in",32-4)
printc("hostile territory",32+4)

if hard then
printc("lives remaining: "..(4-self.deaths),60)
end

printc("resist? "..(self.continue and "yes" or "no"),96-4)
end

function states.resist.update(self)
if not self.fadein and not self.fadeout then
if btnp(4) or btnp(5) then
self.fadeout = 100
sfx(sfxdata.pushstart)
end
if btnp(0) or btnp(1) or btnp(2) or btnp(3) then
sfx(sfxdata.menuscroll)
self.continue = not self.continue
end
end
if self.fadein then
self.fadein = min(100,self.fadein + 4)
pallight(self.fadein)
if self.fadein == 100 then
self.fadein = nil
end
elseif self.fadeout then
self.fadeout = max(0,self.fadeout - 4)
pallight(self.fadeout)
if self.fadeout == 0 then
self.fadeout = nil
if self.continue then
states.game.level = 1
states.cutscene.current = 1
changeState(states.upgrade)
else
nextState = nil
changeState(states.menu)
end
end
end
end
musicdata = {level={},boss={},cutscene={}}
sfxdata = {}

musicdata.menu = 29

musicdata.cutscene[1] = 30 
musicdata.cutscene[2] = 30 
musicdata.cutscene[3] = 30 
musicdata.cutscene[4] = 31 

musicdata.level[1] = 31
musicdata.level[2] = 00
musicdata.level[3] = 19

musicdata.boss[1] = 54
musicdata.boss[2] = 11
musicdata.boss[3] = 48

sfxdata.explosion = 50
sfxdata.bigexplosion = 51
sfxdata.playerdeath = 53
sfxdata.menuscroll = 54
sfxdata.weapon = 55
sfxdata.pushstart = 56
sfxdata.upgrade = 57
sfxdata.cloaking = 58
states.splash = {}

function states.splash.enter(self)
self.load_ss = load_ss('mssinfested',0)
self.fadein = 0
end

function states.splash.draw(self)
cls()
pallight(self.fadein or self.fadeout or 100)
if self.load_ss then
spr(0,0,0,16,16)
else
printb("missing sentinel software",12,64-4)
printb("presents",44,64+4)
end
end

function states.splash.update(self)
if btnp(4) or btnp(5) then
self.fadein = nil
self.fadeout = self.fadeout or 100
end
if self.fadein then
self.fadein += 2
if self.fadein > 100 then
self.fadein = nil
self.fadeout = 100
end
end
if self.fadeout then
self.fadeout -= 2
if self.fadeout <= 0 then
changeState(states.menu)
end
end
end
ss = {
player = {0,2},
player_bullet = 4,
enemy_bullet = 5,
explosion = {6,7,8},
enemy = {
small = {13,14,15,29,30,31},
large = {9,11},
boss = {22,70,32},
},
ui = {
shield = {20,21},
cloak = {41,57},
upgrade = {42,45,90,93},
},
}
story = {
{
{person0='alitahugo'},
{persontext="i'm hit! i'm going down!"},
{place='level1'},
{placetext="hugo said it couldn't happen..."},
{person1='alitahugo'},
{persontext="alita - get out of here!"},
{person0='alitahugo'},
{persontext="hugo!"},
{persontext="don't leave me behind!"},
{person1='alitahugo'},
{persontext="don't worry... i'll be up ahead"},
{persontext="come find me."},
{place='level2'},
{placetext="yet, across the gulf of space"},
{placetext="across 225 million miles"},
{placetext="they came."},
},
{
{place='level2'},
{placetext="when i saw the wreckage"},
{placetext="i knew it was hugo's ship."},
{placetext="my heart sank."},
{placetext="war makes fools of us all."},
{person1='alitahugo'},
{persontext="m ..  ay .. ay d .. may day"},
{persontext="may day - is anyone out there?"},
{person0='alitahugo'},
{persontext="hugo? is that you?"},
{persontext="where are you!"},
{persontext="hugo???"},
{place='level2'},
{placetext="there must be an evil inside us"},
{placetext="an evil that feeds on fear."},
{placetext="today there's something..."},
{placetext="something worth dying for."},
},
{
{place='level2'},
{placetext="as i searched the wreckage"},
{placetext="for any sign of hugo"},
{placetext="my concern faded."},
{placetext="anger boiled up inside of me."},
{placetext="there's no way to brandish"},
{placetext="love as a weapon."},
{person1='mssinfested'},
{persontext="c h i l d  o f  l i g h t"},
{person0='alitahugo'},
{persontext="you!"},
{persontext="you're behind all of this?"},
{person1='mssinfested'},
{persontext="a l i t a . . ."},
{person0='alitahugo'},
{persontext="how..."},
{persontext="how do you know my name?"},
{person1='mssinfested'},
{persontext="a l i t a . . ."},
{persontext="w e  a r e  f o o l s"},
{persontext="w e  l e t  y o u  t a k e"},
{persontext="t h e  s p i r i t"},
{persontext="a n d  c u r s e  m a n k i n d"},
{person0='alitahugo'},
{persontext="what?"},
{person1='mssinfested'},
{persontext="j o i n  u s"},
{persontext="c o m e"},
{person0='alitahugo'},
{persontext="never!"},
{place='level3'},
{placetext="so many lives..."},
{placetext="pointlessly lost in our war."},
{placetext="i may be one as well..."},
{placetext="but it doesn't matter."},
{placetext="without hugo..."},
{placetext="..."},
{person0='alitahugo'},
{persontext="where are you, hugo?"},
},
{
{place='level3'},
{placetext="i was shaking with tears of joy"},
{placetext="the mothership has been..."},
{placetext="destroyed."},
{placetext="amongst the debris..."},
{placetext="i found the infested monster."},
{person0='alitahugo'},
{persontext="why?"},
{persontext="why couldn't you come in peace?"},
{person1='mssinfested'},
{persontext="a l i t a  . . ."},
{persontext="t h e y  d i d ."},
{persontext="e a r t h  d i d  n o t . . ."},
{persontext="l i s t e n . . ."},
{persontext="b u t . . .  y o u  c a m e ."},
{person0='alitahugo'},
{persontext="what?"},
{person1='mssinfested'},
{persontext="y o u  c a m e"},
{person1='alitahugo'},
{persontext="y o u  c a m e"},
{person1='mssinfested'},
{persontext="y o u  c a m e"},
{persontext="i  l o v e  y o u"},
{persontext="a l i t a"},
{place='level3'},
{placetext="i destroyed the mothership"},
{placetext="and there was a moment"},
{placetext="where the earth stood still"},
{placetext="and then erupted in victory."},
{place='level2'},
{placetext="in this brave new world"},
{placetext="if we are to survive"},
{placetext="we must begin anew"},
{placetext="and start all over again"},
{place='level1'},
{placetext="in my rage, i had forgotten"},
{placetext="the pain of losing hugo."},
{placetext="one day, it'll be too much."},
{placetext="but not today."},
{placetext="the end"},
},
}
states.upgrade = {}

function states.upgrade.load(self)
self.m = {
{x=20,y=20,name="fire"},
{x=84,y=20,name="speed"},
{x=20,y=84,name="shield"},
{x=84,y=84,name="cloak"},
}
end

function states.upgrade.enter(self)
self.fadein = 0
self.fadeout = nil
self.selected = 1

for x = 0,127 do
for y = 0,127 do
sset(x,y,spr_orig[x][y])
end
end

self.cost = hard and {250,1000,2500} or {100,500,1000}
end

function states.upgrade.draw(self)
cls()
printc("buy upgrade",0)
for i,v in pairs(self.m) do
if i == self.selected then
rect(v.x-2,v.y-2,v.x+25,v.y+25)
end
spr(ss.ui.upgrade[i],v.x,v.y,3,3)
local name = self.m[i].name.." $"..(self:getupcost(i) or "max")
printf(name,v.x,v.y-8-1,24)
printf(self:getup(i).."/3",v.x,v.y+24+3,24)
end
printc("credits: $"..states.game.player.score,120)
end

function states.upgrade.getup(self,sel)
sel = sel or self.selected
return states.game.player.upgrades[self.m[sel].name]
end

function states.upgrade.getupcost(self,sel)
self = self or self.selected
local upl = self:getup(sel)+1
return self.cost[upl]
end

function states.upgrade.setup(self,val,sel)
sel = sel or self.selected
states.game.player.upgrades[self.m[sel].name] = val
end

function states.upgrade.incup(self)
self:setup(min(3,self:getup()+1))
end

function states.upgrade.update(self)
if not self.fadein and not self.fadeout then
if btnp(0) then
self.selected -= 1
sfx(sfxdata.menuscroll)
end
if btnp(1) then
self.selected += 1
sfx(sfxdata.menuscroll)
end
if btnp(2) then
self.selected += 2
sfx(sfxdata.menuscroll)
end
if btnp(3) then
self.selected -= 2
sfx(sfxdata.menuscroll)
end
if self.selected > 4 then
self.selected -= 4
elseif self.selected < 1 then
self.selected += 4
end
if not self.fadeout then
if btnp(4) or btnp(5) then
local upcost = self:getupcost(self.selected)
if upcost and upcost <= states.game.player.score then
states.game.player.score -= self:getupcost(self.selected)
sfx(sfxdata.upgrade)
self:incup()
else
self.fadeout = 100
end
end
end
end
if self.fadein then
self.fadein = min(100,self.fadein + 4)
pallight(self.fadein)
if self.fadein == 100 then
self.fadein = nil
end
elseif self.fadeout then
self.fadeout = max(0,self.fadeout - 4)
pallight(self.fadeout)
if self.fadeout == 0 then
self.fadeout = nil
changeState(states.game)
end
end
end
__gfx__
77777770077777777777777bb7777777777bb7777777777707077070777777777777777777777000000777777777777777777777070000707007700770000007
7777770bb0777777777777b33b77777777b33b7777777777703003077b73b7b77777777777700bbbbbb007777777777777777777703003070bb00bb003333330
770770b00b07707777b77b3333b77b7777033077777777770303303077b33b7777b77b777703300000033077777770000007777703b33b3003333330037bb730
770770033007707777b77b3333b77b7777b00b7777777777703003077b3bb337777bb777770000333300007770770bb00bb0770770b77b070303303070bbbb07
770770b33b07707777b77b3333b77b777777777777b00b7770300307733bb3b7777bb77770bbbb0000bbbb07030703300330703003b77b300b3333b077077077
70077003300770077bb77b3333b77bb777777777770330770303303077b33b7777b77b7703330b7777b033300b300330033003b0703bb3070b0000b077000077
0b077003300770b0b3b77b3333b77b3b7777777777b33b77703003077b7b37b7777777770330bb7bb7bb03300b003330033300b0770000770077770077777777
00070b3003b07000b3b7b333333b7b3b77777777777bb7770707707077777777777777770330b7bbbb7b03300070333003330700777777777777777777777777
0b00b330033b00b0b3bb33333333bb3b733333377bbbbbb07777777777777777777777770330b77bb77b03307770333003330777770000777700007700000000
0b0b33000033b0b0b33333333333333b3bbbbbb3b3b3b3bb77777777000000007777777770330bb77bb033077770bb3003bb07770033330070333307703bb307
00b3330bb0333b00b33333333333333bb777777b7b3b3b37777777703333333307777777770bbbb00bbbb07777030bb00bb0307707bbbb7003300330770bb077
0b333300003333b0b33333333333333b777777773b3b3b3b7777770333000033307777777770000330000777703070b00b0703070bb77bb0700bb007770bb077
0b333b0bb0b333b0b33333333333333b777777773b3b3b3b7777703300bbbb0033077777777033000033077703007700007700307037730777700777703bb307
0b330000000033b0b333bbbbbbbb333bb777777b7b3b3b3777770330bbbbbbbb03307777777700bbbb0077770b077070070770b070300307770bb07770333307
70b0777007770b077bbb777bb777bbb73bbbbbb3b3b3b3bb7770330bbb7b7bbbb033077777777700007777770b077070070770b07707707770bbbb0770300307
770777777777707777b7777777777b77733333377bbbbbb77770330bbbb7bbbbb033077777777777777777770077777777777700777777770300003000077000
7777777777777777777777777777777777777777777777777770330bbb7b7bbbb033077777777777333333333333333333333333333333333333333333333333
77777777777777777777777777777777777777777777777777703330bbbbbbbb03330777773333773bbbbbbbbbbbbbbbbbbbbbb33bbbbbbbbbbbbbbbbbbbbbb3
7777777777777777000007777770000077777777777777777777033300bbbb00333077777333b3373b77777777777777777777b33b77777777777777777777b3
77777777777777700bbb07777770bbb0077777777777777777777033300000033307777733333b333b77777777777777777777b33b77777777777777777777b3
777777770000777033307777777703330777000077777777777777033333333330777777333333333b77777777777777077777b33b77777777777777777077b3
77777770bbb00703300777700777700330700bbb07777777777770333300003333077777033333303b77777777777777777777b33b77777777700000777777b3
77777770bbbb07033007700bb00770033070bbbb077777777777033330bb770333307777703333073b77777777777770770777b33b000000070b3333007777b3
77777770bbbb0000330000bbbb0000330000bbbb07777777777033330bbbbbb033330777777777773b77777777777077777777b33b03030300bbbb33330770b3
777777700bbbb00000000bbbbbb00000000bbbb00777777777033330b7bb77bb0333307777b77b773b77777777070b07707777b33b0303030bbbbbb3333077b3
77777700000bbb00007700000000770000bbb000007777777770000bbbbbbbbbb0000777b733337b3b7777777030bbb0777777b33b0303030bbbbbbb333077b3
777777033300bbbbb00070700707000bbbbb00333077777777777707bb7bbbb7b0777777730000373b77777003330bbb077777b33b0303030bbbb3bb333307b3
777770bbbbbbb33bbbbb70700707bbbbb33bbbbbbb077777777770bbb00bb00bbb077777300bb0033b77770bb03330b0777777b33b0303030bbb333b333307b3
7777700bbb00033bb00070000007000bb33000bbb0077777777770b0070bb0700b077777300bb0033b77770b0b033307777777b33b0303030bbb3333333307b3
7777770000770333b03300bbbb00330b333077000077777777777707770b707770777777730000373b77777030b03330777777b33b03030300bbb330000307b3
7777777777770333303330bbbb0333033330777777777777777777777770077777777777b733337b3b777703330b0307777777b33b030303070bbb07777007b3
7777777777777003330330bbbb033033300777777777777777777777777777777777777777b77b773b7770b03330b077777777b33b03030307700077777707b3
7777777770000330333000bbbb0003330330000777777777777777777777777777777777777777773b7770bb030bb077777777b33b03303030777777777777b3
7777777003333333033b00000000b3303333333007777777777700777777777777777777770077773b7770bbb0700777777777b33b00000000777777077707b3
777770033333330000330330033033000033333330077777777000077777700000077777700007773b77770007777777777777b33b77777777777777777777b3
777703333000003333000bb00bb000333300000333307777777033000070003333000700003307773b77777777777777777777b33b77777777777777777777b3
7777033000770b33300b00000000b00333b07700033077777770033bb00000033000000bb33007773b77777777777777777777b33b77777777777777777777b3
777003007700bb330330b033330b033033bb0077003007777777000bbbbb0b0000b0bbbbb00077773b77777777777777777777b33b77777777777777777777b3
7770330770bbb3303330b033330b0333033bbb077033077777770000bbbb00b00b00bbbb000077773bbbbbbbbbbbbbbbbbbbbbb33bbbbbbbbbbbbbbbbbbbbbb3
7770b3000bbb3303330bb0bbbb0bb0333033bbb0003b07777700033bbbbbb000000bbbbbb3300077333333333333333333333333333333333333333333333333
7770bbb0bbb33033300bb000000bb00333033bbb0bbb077777033300bb000333333000bb00333077333333333333333333333333333333333333333333333333
7777000bbb33033300300b0330b00300333033bbb000777777000000bb070033330070bb000000773bbbbbbbbbbbbbbbbbbbbbb33bbbbbbbbbbbbbbbbbbbbbb3
777770bbb330333003003003300300300333033bbb0777777777770bb07770033007770bb07777773b777b77777b7777777777b33b77777777777777777777b3
777770bbb303330303033000000330303033303bbb07777777777703b07777033077770b307777773b777777777777777b7777b33b77777777777777777777b3
777700bbb033330303003303303300303033330bbb007777777777003300770330770033007777773b77777777777777777777b33b77777777777777777777b3
77770bb00033303303300b0bb0b00330330333000bb07777777777700030000330000300077777773b77777700000007777777b33b77777777700777777777b3
77770b003033033330330000000033033330330300b07777777777777033333333333307777777773b77770003333300077b77b33b77700777700777700777b3
77770b03303000333303b077770b30333300030330b077777777000000bb33333333bb00000077773b7b770333333333307777b33b77770077700777007777b3
77770bb0033077033330b077770b0333307703300bb077777770b333333bbbbbbbbbb333333b07773b7770033333bb33307777b33b77777777777777777777b3
00070bbb03007770333300777700333307770030bbb0700077003b3333333bb00bb3333333b300773b777033333bbbb3307777b33b77777700000000777777b3
0b30300b03077777033307777770333077777030b00303b0770b300003333307703333300003b0773b777033333bbbb3330777b33b77777033333333077777b3
003300bb03077777703330777703330777777030bb003300700300770033330770333300770030073b7770333333bb33330777b33b77770333000033307777b3
77000bb0033077777703330770333077777703300bb00077703b077003b3300770033b300770b3073b77703333333333330777b33b77003330bbbb03330077b3
77770b077033007777703b0770b307777700330770b07777703307003300007777000033007033073bb77033333333333077b7b33b77033300000bb0333077b3
777700777703300777703b0770b307777003307777007777700b000bb00777777777700bb000b0073b77700333333333307777b33b77003330000003330077b3
77777777777033077703bb0770bb307770330777777777777700b003b07777777777770b300b00773b77770333333333307777b33b77770333000033307777b3
7777777777033307770bbb0770bbb0777033307777777777777000033077777777777703300007773b77770333333333077777b33b77777033333333077777b3
777777777033bb07777000777700077770bb33077777777777777700b00777777777700b007777773b77777000333000777777b33b77777700000000777777b3
7777777003bbb0777777777777777777770bbb3007777777777777703300777777770033077777773b7b7777770007777777b7b33b77777777777777777777b3
7777770bbbbb077777777777777777777770bbbbb0777777777777700330777777770330077777773b77777777777777777777b33b77777777777777777777b3
7777770bbbb07777777777777777777777770bbbb0777777777777770000777777770000777777773b77777777777777b77777b33b77777777777777777777b3
777777000007777777777777777777777777700000777777777777777700777777770077777777773b7777777b777777777777b33b77777777777777777777b3
777777777777777777777777777777777777777777777777777777777777777777777777777777773bbbbbbbbbbbbbbbbbbbbbb33bbbbbbbbbbbbbbbbbbbbbb3
77777777777777777777777777777777777777777777777777777777777777777777777777777777333333333333333333333333333333333333333333333333
7777733b33b33b3333bb7b7bbb7b7b7bbb77bb7b7bbb33333377bbbbbb7bb7777777777777777777777777777777777777777777777777777777777777777777
7777b33b3bb3bb33bbbb777b777b7b7bbbbbbbbbbbbbb33333777bbbbb7b77777777777777777777777777777777777777777777777777777777777777777777
77773333bbbbbb3bbbbbbb7bbb77bbbb3333bbbbbbbbbbbbbbbb7777777b77777777777777777777777777777777777777777777777777777777777777777777
7777333377b777bb3bbbbbbb3bbbbbbbbbb3bbbb7b77b7bbbbbbb777777bb7777777777777777777777777777777777777777777777777777777777777777777
7777333377bbb7bbbbbbbb373bbbbbbb7bbbbbbbb7b7b77bbbb7b77777bbb7777777777777777777777777777777777777777777777777777777777777777777
77773333777b7bb33333333733bbbbbb777777777bbbbb777bbbb77777bbb7777777777777777777777777777777777777777777777777777777777777777777
77773333377b7bbbb3b3333b3bbbbbb377777777bbbb3333bbbbb7777bbb77777777777777777777777777777777777777777777777777777777777777777777
777733333bb7bbbbb3333bb333bbb333b777777bbbbb33333bbbbbb7bbbb77777777777777777777777777777777777777777777777777777777777777777777
777733333bb777777bbbbbb333bbb333bb777777b7b77b333bbbb33bb7b7777777777777777777777777777777777777777777777777777777777b7777777777
77773333b737777777bbbbbb33b333333b777b7bbbb77b3333bbb333bbbbb777777777777777777777777b7777777777777777777777777777777b7777777777
7777bbb33b337777773bbbbb333bb33333b7bbbbbbbbb3333bbbb777777bb777777777777777777777777b777777777777777777777777777777b3b777777777
7777777b3333377777bbbbbbbbbbb33333bbbb77bbbb33b33bb77777777b777777777777777777777777777777777777777777777777777777777b7777777777
7777bbbb3333337777b333bb3b77b33333bb3b77bb333bb3bbb7777b777777777777777777777777777777777777777777777777777777777777777777777777
7777b3bb333333bb3bbbb3bbbb77b33bb3bb3b77b33b33b3bb33b77b7777b7777777777777777777777777777777777777777777777777777777777777777777
7777b333333333bb37777777777bbbb33b3b3777bbbb7b77777777737777b7777777777777777777777777777777777777777777777777777777777777777777
7777b3333333333bbb777777777bbbbb3bbb3777333b7777777777b377b777777777777777777777777777777777777777777777777777777777777777777777
7777b3333333333b33b7b77777b333333b77bbbb3333bbbbbbbbbb3b7777b7777777777777777777777777777777777777777777777777777777777777777777
77777bb33733333b333b777b77b333333777b33333333333333333b7b7bbb777777777777b777777777777777777777777777777777777777777777777777777
777777b337b3333b3333b777b7b3333337bbbb3333333333333333b777bbb777777777777b777777777777777777777777777777777777777777777777777777
777777b337b3333b33333777bb3333333bbbbbb3b3333b333333333bbbbb777777777777b3b77777777777777777777777777777777777777777777777777777
77777733b7b3333333333b77bb333bb33bbbbbbbbbb33b333b3333333bbbb777777777777b777777777777777777777777777777777777777777777777777777
77777b33b7bbbbbb33333bb77bbbbb73bbbbbbbbbbb33b33333333333bbbb7777777777777777777777777777777777777777777777777777777777777777777
7777733377bbbbb33333333bb777777bbbbbbbbbbb333333333333333bbbb77777777777777777777777777777777777777777b7777777777777777777777777
77777b3377b777b3333333333bbbbbbbbbbbbbb7b3333333b3333333377bb77777777777777777777777777777777777777777b7777777777777777777777777
77777bb377bbb77333b333333333333bbbbbbbbb3333b333b3333333b77bb7777777777777777777777777777777777777777b3b777777777777777777777777
7777b33b77b7777bb7bb3333333b777777777bbb3333b333b3333333b77b7777777777777777777777777b7777777777777777b7777777777777777777777777
7777b33b777777777777b333333b7777b7777bb33333b3333333333377bb7777777777777777777777777b7777777777777777777777777777777b7777777777
7777b33377bb7bb777777b333bbb3b7bb7b7bbb333bbb333b333b33377bb777777777777777777777777777777777777777777777777777777777b7777777777
7777b3337bbbbbb77bbbb7333bb333bbbb77777777777bb777bb7bbb77bbb7777777777777777777777777777777777777777777777777777777777777777777
7777b33b7bbb7b3777bbb7733b33333b77b7777b77777bb777bbb777b7bb77777777777777777777777777777777777777777777777777777777777777777777
7777b3337bbbbb377b3b7777bbb33333777777b7777773b777bbbbbbbbbb77777777777777777777777777777777777777777777777777777777777777777777
7777733b77b7bb3bb33b77777bb333333777777777b7b3b7773b33bbbbbb77777777777777777777777777777777777777777777777777777777777777777777
7777733b7777773bb33b77b777b33333337777777b33b7b7bbbb3bbbbbbbb777333b7777777777bb7777bb3333333333333777777bbbb77bb777777777777777
77777bbb77b7777b7bb77777777b33333337777777bbb7bbbbb3bbbbbbbbb777333b77777777777bb77bb333333333777777bbbbbbbbbbbb77777777777777bb
77777bbb77b77b77777b7777777733333333bbbbbbbb3b7bbb7bb7b7777bb777333bb77777777777bbbb333333337777bbbbb7bbbbbbbbbb7777bb7777777bb7
7777bb33bbbbbb7777bbbbbbbbbb3333333333333b7bb77bbbbbb777777b7777333bb777777777777bbb733333777bbbbb77bbb77777777bb77bbbb7777bbb77
7777b33333bb73bbb3333bb3bbbb333333333bbb3bbbbbb7bbbb777777bb77773333bb7777777777777bbbb7777777777bbbb77777777777b77b77bb7bbb7777
7777b333b33b7b3333333bb3bbb3333333333333333333bbbb3333333bbbb77733377bb777777777777777bbbbbbbbbbbb7777777bbbbb77bbb7777bbbbbbbbb
7777b333bbb7bb333bbb3bbbbbbbb3b3333333333bbbb3bbbbb3bbbbbbb7b7773337bbbb7777777777777777777bbbb77777777777777bbbbb777777bbbb7777
7777b333b7bbbb3b777777777b777b7b7b3333b77777b7777777333bb3bb7777333bb77bbb777777777777777777777777777777777777bbb7777777bbb77777
7777bb33b7bb7b3b7bb7777773777777773333377bb7b7777777bbb77bb77777333b77777bbbb777777777777777777777777777777777bb777777777bbb777b
77777733bbb77b3b7b7777777bb777777733bb33b777b777777773b7b3377777333b77777777bbb7777777777777777777777777777777bb7777777777bbbbbb
77777333bb3b733b7bbb7777bb3b777777bbbb333b7777777b77bbb7b3b77777333b777777777bbbb77777777777777777777777777777bb777777777777bb77
77777b33bb3b73b7bbbbbb7bbb33777777bb7b3333bb77777b7b37bbb3b7777733bb777777777b777bbbbbbbbbbbbbbbbbbbbbb77777bbbbb7bb77777777777b
777777733b3bb377777bbbb3333b777777777b3333b3b777777337b7bbbb7777337b777777777bb777777777777bbbbbbbbbbbbbbbbbbb77bbbb77777777777b
777777733333b377777b777333377bb7777b7b3333333b7777777777bb7bb77733bb7777777777b7777777777bbb7733333333333337777bbbbb77777777777b
77777bb33333337777777b7b33377b7777777733333333b7777777773bb77777333b7777777777b77777777bbb33333333333337777bb777bbb777777777777b
7777bb33333333bbb7bb33bb3b377b777b777733333333bbb77bbbb73bb77777333b7777777777bb77777bbb3333333333777bbbbbbbb77bb77777777777777b
7777bb33bb33333bbbb333333b73333333bbbbb77b3333bbbbbb7b3b3b7b7777333b77777777777bb77bb33333333377777bbbbbbbbbbbbb77777777777777bb
7777bb3bbb3bbbbbb7777777b77b7bb7777bbb777bb333b3b7733bbb3bbb7777333bb77777777777bb7b333333337777bbbbb7bbbb77bbbb7777bb7777777bb7
7777b33b77b777b7b777777777777bb77bb333b7b77333b3b7733bb33bb37777333bb777777777777bbbb3333377777bbbb7bbb77777777bb77bbbb7777bb777
7777b33b77777b77b777777777777b77b7bbb3b7b777b3b3333337733bbb77773333bb7777777777777bbbbbb777777777bbb77777777777b77b77bbbbbbb777
7777b33bbb777b7b7777777777777bb777b3bbb7bb777bb33333bbbbb73b777733337bb777777777777777bbbbbbbbbbb777777777b7bb77bbb7777bbbbbbbbb
7777bb3b77777bbbb77777b7bb7bbbbbbbb33bb7b3b77bb3333333bbb7bb777733377bbb7777777777777777777bbbb777777777777777bbbb777777bbb77777
777777bb77777b333bb777773bbbb7bbbb333bbbb37777bb333333bbb77b77773337bb7bbb777777777777777777777777777777777777bb77777777bb777777
7777777b77b77b33333777773b3b3bbbbb3333bbbb777777333333b777777777333bb7777bbbb777777777777777777777777777777777bb777777777bbb777b
7777777b77777b3b333b7b77b3bbbbbbbb3333bb3b77777b3333337777777777333b77777777bbbb777777777777777777777777777777bb7777777777bbbbbb
7777733bbbbb7b3bb33bbb7777bbbb3bbbb3bbbbbb77777b33333bbb77777777333b7777777777bbbb777777777777777777777777777bbbb777777777777b77
7777733b7bbbbbbb333bbbbbb73b333bbbb3bb733bbbbb7b33333b7777777777333b777777777bbb77bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb77777777777b
77777b3b777777bb3bbbb3b3333333333b3333333337b7bb33333b777777777733bb777777777b777777777777bbb77bbbbbbbbbbbbbb377bbbb77777777777b
7777bb3b7777777777b7bb77777bbb33b333333333b7777b33333b7bb7777777337b777777777bb777777777bbb773333333333333377777bbbb77777777777b
7777b337777777bb77777777777b7b33bbb3b33333bbbb7b33333377b77b777733bb7777777777b77777777bbb73333333333337777777777bb777777777777b
77773337777777b77b777777b7b3b333bb7777b33b3b777b33333337777b7777333b7777777777b777777bbb33333333337777bbbbbb7777b7b777777777777b
7777333b77777bb3b37b7777b7b33bb3bb777b777b3bbb7b3b33bb33777b7777333b7777777777bb777bb33333333377777bbbbbbbbbb77bb777777777777bbb
__gff__
__map__
__sfx__
010d00000c655346050c6350c6053c6550c6050c6353c6050c6550c6050c6350c6053c6550c6050c6353c6050c655346050c6350c6353c6550c6050c6350c6353c6550c6350c6050c6350c6050c6353c65500605
010d00000c655306350c6350c6353c6550c6050c6553c6050c6550c6050c6450c6453c6550c6350c6053c6350c6553c6350c6350c6353c6550c6050c6350c6353c6550c6350c6353c6550c6350c6353c65500005
010d0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000034751337513275131751307512f7512e7512d7512c751
010d02000c6500c6500c6400c6400c6400c6400c6300c6300c6300c6300c6300c6200c6200c6100c6100c61000000000000000000000000000000000000000000000000000000000000000000000000000000000
010d00000406023000100600000004060000001006000000040600000010060000000406000000100600000002060230000e0600000002060000000e0600000002060000000e0600000002060000000e0600e005
010d00000406023000100600000004060000001006000000040600000010060000000406000000100600000007060000001306513065060600000512065120650406000005100651006502060000050e0650e065
010d000013201152001f2521f2001c2521a252002001c2521c2521c2521c2531c202172521a2521c2521a2521a2521a2521a2521a2521a2521a2552125122251002002225221252002001f252002001c2521c253
010d000013206152061f2521f2061c2521a252002021f2521c2061c2521c2531c2061f2521c2521a2521f2521a2061b2521b2551b206212521f23221242222522123222242232522223223242262522723228253
010d00001320115200232521f2001f2521c252002001f2521f2521f2521f2531c2021a2521c2521f2521e2521e2521e2521e2521e2521e2521e25524251262510020026252252520020023252002001f2521f253
010d00000c655346050c6350c6053c6550c6050c6353c6050c6550c6050c6050c6053c6550c6050c6053c6050c655346050c6050c6053c6550c6050c6053c6050c6550c6050c6050c6053c6550c6050c6050c605
010d000013202152021f2521f2021c2521b2021a2621725216202152522120217202172721620215252122721120210262102021f202212020e252202020e2521f2020e252122020e252112020e252102020e202
010d00001320615206232521f2061f2521e25200202232521c2061f2521f2531c206232521f2521e252232521a2061f2521f2531b2061c2521a2321c2421d2521c2321d2421e2521d2321e242212522223223253
010d00000c655346050c6350c6053c6050c6050c6350c6353c6550c6050c6350c6053c6050c6050c6053c6050c655346050c6350c6053c6050c6050c6350c6353c6550c6050c6350c6350c6050c6353c6550e004
010d00000445404451044510445104451044510445104451044510445104452044520445204452044520445210451104511045110451104511045110451104511045210452104521045210452104521045210452
010d00000b4440b4410b4410b4410b4410b4410b4410b4410b4410b4410b4420b4420b4420b4420b4420b44217441174411744117441174411744117441174411744217442174421744217442174421744217442
010d00000c655346050c6050c6553c6050c6050c6550c6053c6550c6550c6050c6050c6550c6050c6050c6550c605346050c6550c6053c6050c6550c6050c6053c6550c6050c6050c6350c6050c6053c6550c635
010d00000a4510a4510a4010a4510a4530a4010a4510a4510a4010a4510a4510a4010a4510a4510a4010a4510a4530a40101454014500940101450014530a4020745507453074530745507453074530745307405
010d00001144111441114011144111443114011144111441114011144111441114011144111443114011144111441124010844408440114010844008443124010e4450e4430e4430e4450e4430e4430e44312401
010d00000a4510a4510a4010a4510a4530a4010a4510a4510a4010a4510a4530a40115454154510a40109451094530a4011745417453094010b4500b4530a4020745507453074530745507453074530745307405
010d000011441114411140111441114431140111441114411140111441114431140104440044400540110441104430640106444064431140406440064431e4010e4450e4430e4430e4450e4430e4430e4430e405
010d00003060524605186050c6051f2511f2521f2421f2451c2501c2521a2501a2521a2451a2021c2501c3521c2521c3521c2521c3421c2421c3421c2321c23217252172521a2521a2521c2521c2521a2521a252
010d00001a2521a2521a2521a3521a2521a3521a2421a3421a2421a2421a2321a2321a20318000222502224018000222002225022240212502124018000180001f2501f24018000180001c2501c2401c3401c240
010d0000132011520011201112041f2511f2521f2421f2451c2501c2521a2501a2521a2451a2021c2501c3521c2521c3521c2521c3421c2421c3421c2321c23217252172521a2521a2521c2521c2521d2521d252
010d00001d1521d2521d3521d4521d5521d7521d5421d7421d5421d4321d3321d2321d1221d2221d3221d4221d5221d7221d5221d7221d5221d4221d3221d4221d5221d7221d5221d4221d3221d2221d1221d202
010c0000180531f0031800318003180531f0031800318003180531f0031800318003180531f0031800318003180531f0031800318003180531f0031800318003180531f0031800318003180531f0031800318003
011000000c050130500c050130500c050130500c050130500c050130500c050130500f050160500f050160500f050160500f050160500f050160500f050160500f000160000f000160000f000160000f00016000
011000000e050150500e050150500e050150500e050150500e050150500e050150500d050140500d050140500d050140500d050140500d050140500d050140500d000140000d0001400000000000000000000000
010c00000000000000000000000000000000000000000000000000000000000000000000000000000000000000410004110144101441024110241103441034410441104411054410544106411064110745107451
010c0000084110841109451094510a4110a4110b4610b4610c4110c4110d4610d4610e4110e4110f4710f47110411104111147111471124111241113471134711441114411236512f6613b6712f6412363117631
011000002c3502b350253502435224352243522435224352003002a3502b35029350273501b3502735033350273501b350273522735227352273511b3510f3510030000300003000030000300003000030000300
0110000017631176311762117621176111761117611236112361123621236312f6412f6512f6612f6013b67500000000000000000000000000000000000000000000000000000000000000000000000000000000
01100000263501a3502635032350263501a350263522635226352263511a3510e35125350193502535031350253501934022350223522e2522e2523a1523a1520000000000000000000000000000000000000000
011000000060000600006000060000600006000060000600006000060000600006000060000600006000060000600006003c6453c6253c6453c6253c6453c6250060000600006000060000600006000060000600
011000001325213253132521805318053180531125211253112521805318053180531025210253102521805318053180530f2520f2530f252180531805318053180031f0031800318003180031f0031800318003
011000000c2520c2530c2521800318005180050a2520a2530a2521800518005180050925209253092520000500005000050825208253082520020000200002000020000200002000020000200002000020000200
011000001f2501f2531f2501820018200222001d2501d2531d2501820018200182001c2501c2531c2501820018200182001b2501b2531b2500020000200002000020000200002000020000200002000020000200
010c00003b6312f6312f6212f62323621236211761117611180031f0031800318003180031f0031800318003180031f0031800318003180031f0031800318003180131f0031800318003180031f0031800318003
011000000000000000000002c3302b34025350193010d301000003a330353402f3502335117351000002d330283402333022352223522e2522e2523a1523a1520000000000000000000000000000000000000000
011000003a1522e151222512c3302b3402535019301393013a3013b3303634024350183510c3511a1332c3352f245321353a1523a1522e2522e25222352223520000000000000000000000000000000000000000
010700003523500205272151b205302550020535235292052e23500205302152420533235002052e21522205292350020533215272052423500205292151d2052223500205242151820527235002052221516205
010700000801008010080100801008010080100801008010080100801008010080100801008010080100801008010080100801008010080100801008010080100801008010080100801008010080100801008011
010700000a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a0100a011
010700000501005010050100501005010050100501005010050100501005010050100501005010050100501005010050100501005010050100501005010050100501005010050100501005010050100501005011
011000003c645000003c6113c6453c6253c6253c645000003c6153c6453c6253c6253c645000003c6113c6453c6253c6253c645000003c6453c6053c6453c6050000000000000000000000000000000000000000
01100000001000010000100181501b1501f15022150221502215022152221520010021150211551d1501d15518150181501815218152181521815218152181520010000100001000010000100001000010000100
01100000001000010000100181501b1501f150221501f15024150241522215224150261502615522150221551f1501f1501f1521f1521f1521f1521f1521f1520010000100001000010000100001000010000100
011000000c07000000080000c0700c0000c0000c07000000080000c0700c0000c0000c07000000080000c0700c0000c0000c070000000c070071000c070000000000000000000000000000000000000000000000
011000000807000000080000807008000080000807000000080000807008000080000807000000080000807008000080000807000000070700710007070000000000000000000000000000000000000000000000
010c0000180132f6012f6012f60323601236011760117601180031f0031800318003180031f0031800318003180031f0031800318003180031f0031800318003180131f0031800318003180031f0031800318003
011000001815016150180501a150181501a1501b1501a1501b1501d1521b1521d1501f1551f1551f1521f1051f1551f1551f1521f1021f1021f1021f1021f1020010000100001000010000100001000010000100
01060000246432464118630186300c6200c6200c6100c610006110060000600006000060000600006000060000600006000060000600006000060000600006000060000600006000060000600006000060000600
010c00001864330650186530c6500c6400c653246400c64100641246532464118641246410c6310c631246530c64100641246312463118620186200c6100c6100c6200c620006110061000610006200061000610
010d0000184501745018450174501b450174501b450174501f450174501f45017450224501745022450174503a440224402e440164433a4303a430224332e430164203a420224202e4203a420224202e42016420
0108000005430064300d4400f44015440224401e450224502a4502b45032450394500040000400394500040000400394400040000400394300040000400394200040000400394100040000400394100040000400
010200002903029030290302903024030240302403024030240000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
01020000321202d1202813024140201401d1301812014110101100d11009130051000110000100001000010000100001000010000100001000010000100001000010000100001000010000100001000010000100
010800001143015430184401c4401d430214302444028440294302d43030440344403040030400344503040030400344403040030400344303040030400344203040030400344103040030400344100040000400
01090000183501c3401f3401a3501e340213401c350203402334025300173001c3000030000300003000030000300003000030000300003000030000300003000030000300003000030000300003000030000300
010300001861118611186111a6111c6211d6211f6312163123641246112661128621296212b6312d6312f641246112661128621296212b6312d6312f6412f6413061132611346213562137631396313b6413b641
01100000001000010000100181501b1501f150221501f15024150241522215224150261502615522150221551f1501f1501f1521f1521f1521f1521f1521f1520010000100001000010000100001000010000100
011000000507000000080000507000000000000507000000080000507000000000000507000000080000507000000000000507000000050700710005070000000000000000000000000000000000000000000000
010d0000350252701530025350152e03530115331352e115351452712530145351252e25530235332552e235292651b2452426529245222652424527275222551d2750f255182751d25516265182451b26516235
010d0000212201d22018220212201f253212301d23018230212301f253212401d24018240212401f253212501d25018250212501f2533125025350191500d25031340192400d13025330012200d3201911025210
000d00001a450174501a450174501c450174501c450174501d450174501d450174501c450174501f450174501d4501745020450174503125025350191500d25031340192400d13025330012200d3201911025210

__music__
00 41010244
01 03000406
00 40000507
00 40000406
00 4804090a
00 43400409
00 43054609
00 03400608
00 0b400709
00 43090608
02 0b400709
01 400c0d0e
00 450f1011
00 420c0d0e
00 450f1213
00 0e0c0d14
00 130f1015
00 0e0c0d16
02 170f1213
01 18195844
00 181a5844
00 18191b44
00 181a1c44
00 181d191e
00 181a1f20
00 181d191e
00 181a1f20
00 24222521
02 24222621
03 27424344
03 3d424344
01 302b2c2e
00 302b2d2f
00 302b2c2e
00 302b312f
00 182b313c
00 182b312f
00 182b2c3c
00 182b2d3c
00 1820033c
00 1820733c
00 181b203c
00 181c603c
00 182b2c19
00 182b2d1a
00 182b2c19
00 182b2d1a
02 182b2d1a
00 3d4b4d4e
00 3d0f4c51
01 3d0c0d0e
00 3d0f1011
00 3d0c0d0e
02 3d0f1213
00 242b4d4e
00 030c0d0e
00 7e0f1011
00 7e0c0d0e
00 3e0f1213
01 340c0d0e
00 3f0f1011
00 340c0d0e
02 3d0f1213
00 424c4d4e

